!
! Module: test_mod
!
! Authors:  Ian Stewart - SSC/LUX
!          
! Description: Contains test routine for asmooth.
! 
! Comments: TODO:
! 
! $Id: test_mod.f90,v 1.6 1998/05/27 13:45:39 gvacanti Exp $
!- 
module test_mod

  use dal

  use random_aux
!  use asmooth_common

  implicit none 

  private 

  public saveTestImages

contains 

  !---------------------------------------------------------------------
  subroutine saveTestImages(templateImage)
  !---------------------------------------------------------------------

    implicit none

    real(single), intent(in) :: templateImage(:,:)

    integer(int16) :: xSize, ySize, i, xi, yi, xxi, yyi
    integer ::&
      eventImage(size(templateImage,1),size(templateImage,2)),&
      packedEventImage(size(templateImage,1)*size(templateImage,2))
    real(single) :: convolverCube(5,7,9)
    integer(int32) :: indexImage(size(templateImage,1),size(templateImage,2))
    integer(int32), pointer ::&
      newDimVector(:)
    type(DataSetT) :: set
    type(ArrayT) :: newArray, convCube
!    real(single), pointer ::&
!      arrayDataReal32(:,:)
    integer(int32), pointer ::&
      arrayDataInt32(:,:)
    real(single), pointer :: convCubeData(:,:,:)

    !-------------------------------------------------------------------
    ! Start:

    xSize = size(templateImage,1)
    ySize = size(templateImage,2)

    ! Make random image:

    call getPoissonRandoms(0.05, packedEventImage)

!    eventImage = unpack(packedEventImage, templateImage, 0)
    eventImage = reshape(packedEventImage, (/xSize,ySize/))

    allocate(newDimVector(0:1))
    newDimVector = (/xSize, ySize/)

    set = dataSet('test_image.ds', CREATE)
!    newArray = addArray(set, "PRIMARY", REAL32, newDimVector)
    newArray = addArray(set, "PRIMARY", INTEGER32, newDimVector)

!    arrayDataReal32 => real32Array2Data(newArray)
!    arrayDataReal32 = eventImage
    arrayDataInt32 => int32Array2Data(newArray)
    arrayDataInt32 = eventImage

    deallocate(newDimVector)
    call release(set)


    ! Make convolvers/indexImage:

    i = 1
    convolverCube(:,7,i) = (/0,0,1,0,0/)
    convolverCube(:,6,i) = (/0,1,1,0,0/)
    convolverCube(:,5,i) = (/0,0,1,0,0/)
    convolverCube(:,4,i) = (/0,0,1,0,0/)
    convolverCube(:,3,i) = (/0,0,1,0,0/)
    convolverCube(:,2,i) = (/0,0,1,0,0/)
    convolverCube(:,1,i) = (/0,1,1,1,0/)

    i = 2
    convolverCube(:,7,i) = (/0,1,1,1,0/)
    convolverCube(:,6,i) = (/1,0,0,0,1/)
    convolverCube(:,5,i) = (/0,0,0,0,1/)
    convolverCube(:,4,i) = (/0,0,0,1,0/)
    convolverCube(:,3,i) = (/0,0,1,0,0/)
    convolverCube(:,2,i) = (/0,1,0,0,0/)
    convolverCube(:,1,i) = (/1,1,1,1,1/)

    i = 3
    convolverCube(:,7,i) = (/0,1,1,1,0/)
    convolverCube(:,6,i) = (/1,0,0,0,1/)
    convolverCube(:,5,i) = (/0,0,0,0,1/)
    convolverCube(:,4,i) = (/0,0,0,1,0/)
    convolverCube(:,3,i) = (/0,0,0,0,1/)
    convolverCube(:,2,i) = (/1,0,0,0,1/)
    convolverCube(:,1,i) = (/0,1,1,1,0/)

    i = 4
    convolverCube(:,7,i) = (/0,0,0,0,1/)
    convolverCube(:,6,i) = (/0,0,0,1,0/)
    convolverCube(:,5,i) = (/0,0,1,0,0/)
    convolverCube(:,4,i) = (/0,1,0,0,0/)
    convolverCube(:,3,i) = (/1,0,1,0,0/)
    convolverCube(:,2,i) = (/1,1,1,1,1/)
    convolverCube(:,1,i) = (/0,0,1,0,0/)

    i = 5
    convolverCube(:,7,i) = (/1,1,1,1,1/)
    convolverCube(:,6,i) = (/1,0,0,0,0/)
    convolverCube(:,5,i) = (/1,1,1,1,0/)
    convolverCube(:,4,i) = (/0,0,0,0,1/)
    convolverCube(:,3,i) = (/0,0,0,0,1/)
    convolverCube(:,2,i) = (/1,0,0,0,1/)
    convolverCube(:,1,i) = (/0,1,1,1,0/)

    i = 6
    convolverCube(:,7,i) = (/0,1,1,1,0/)
    convolverCube(:,6,i) = (/1,0,0,0,1/)
    convolverCube(:,5,i) = (/1,0,0,0,0/)
    convolverCube(:,4,i) = (/1,1,1,1,0/)
    convolverCube(:,3,i) = (/1,0,0,0,1/)
    convolverCube(:,2,i) = (/1,0,0,0,1/)
    convolverCube(:,1,i) = (/0,1,1,1,0/)

    i = 7
    convolverCube(:,7,i) = (/1,1,1,1,1/)
    convolverCube(:,6,i) = (/0,0,0,0,1/)
    convolverCube(:,5,i) = (/0,0,0,0,1/)
    convolverCube(:,4,i) = (/0,1,0,1,0/)
    convolverCube(:,3,i) = (/0,0,1,0,0/)
    convolverCube(:,2,i) = (/0,1,0,1,0/)
    convolverCube(:,1,i) = (/1,0,0,0,0/)

    i = 8
    convolverCube(:,7,i) = (/0,1,1,1,0/)
    convolverCube(:,6,i) = (/1,0,0,0,1/)
    convolverCube(:,5,i) = (/1,0,0,0,1/)
    convolverCube(:,4,i) = (/0,1,1,1,0/)
    convolverCube(:,3,i) = (/1,0,0,0,1/)
    convolverCube(:,2,i) = (/1,0,0,0,1/)
    convolverCube(:,1,i) = (/0,1,1,1,0/)

    i = 9
    convolverCube(:,7,i) = (/0,1,1,1,0/)
    convolverCube(:,6,i) = (/1,0,0,0,1/)
    convolverCube(:,5,i) = (/1,0,0,0,1/)
    convolverCube(:,4,i) = (/0,1,1,1,1/)
    convolverCube(:,3,i) = (/0,0,0,0,1/)
    convolverCube(:,2,i) = (/1,0,0,0,1/)
    convolverCube(:,1,i) = (/0,1,1,1,0/)

!convolverCube(:,1:7,:) = convolverCube(:,7:1,:)

    do xi = 0, 2
      xxi = 1 + xi * (xSize / 3)
      do yi = 0, 2
        yyi = 1 + yi * (ySize / 3)
        i = 3 * xi + yi + 1
        indexImage(xxi:,yyi:) = i
      end do
    end do

    allocate(newDimVector(0:1))
    newDimVector = (/xSize, ySize/)

    set = dataSet('test_convolvers.ds', CREATE)
    newArray = addArray(set, 'INDEXIMG', INTEGER32, newDimVector)

    arrayDataInt32 => int32Array2Data(newArray)
    arrayDataInt32 = indexImage

    deallocate(newDimVector)


    allocate(newDimVector(0:2))
    newDimVector = (/size(convolverCube,1), size(convolverCube,2)&
      , size(convolverCube, 3)/)

    convCube = addArray(set, 'CONV_000', REAL32, newDimVector)
    convCubeData => real32Array3Data(convCube)
    convCubeData = convolverCube

    deallocate(newDimVector)
    call release(set)


  end subroutine saveTestImages

  !---------------------------------------------------------------------
  subroutine template
  !---------------------------------------------------------------------

    implicit none

    !-------------------------------------------------------------------
    ! Start

  end subroutine template

end module test_mod
